/************************************************************************************/
/*  Program name CAPFNDEXT_CONC_PROG_FLEX.sql                                       */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_CONC_PROG_FLEX';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_CONC_PROG_FLEX.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		FDF.*
	FROM
		FND_CONCURRENT_PROGRAMS		FCP, 
		FND_CONCURRENT_PROGRAMS_TL	FCPT, 
		FND_DESCRIPTIVE_FLEXS		FDF
	WHERE	FCP.Application_ID				=	FCPT.Application_ID
	AND		FCP.Concurrent_Program_ID		=	FCPT.Concurrent_Program_ID
	AND		FCPT.Language					=	'US'
	AND		SUBSTR(FCP.Concurrent_Program_Name,1,4)	=	p_NGO
	AND		FDF.Descriptive_Flexfield_Name	=	'$SRS$.'||FCP.Concurrent_Program_Name
	ORDER BY
		FDF.Application_ID,
		FDF.Descriptive_FlexField_Name;

BEGIN
	lv_NGO			:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Application_ID||CHR(9)||
				C1.Application_Table_Name||CHR(9)||
				C1.Descriptive_FlexField_Name||CHR(9)||
				C1.Table_Application_ID||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Context_Required_Flag||CHR(9)||
				C1.Context_Column_Name||CHR(9)||
				C1.Context_User_Override_Flag||CHR(9)||
				C1.Concatenated_Segment_Delimiter||CHR(9)||
				C1.Freeze_Flex_Definition_Flag||CHR(9)||
				C1.Protected_Flag||CHR(9)||
				C1.Default_Context_Field_Name||CHR(9)||
				C1.Default_Context_Value||CHR(9)||
				C1.Context_Default_Type||CHR(9)||
				C1.Context_Default_Value||CHR(9)||
				C1.Context_Override_Value_Set_ID||CHR(9)||
				C1.Context_Runtime_Property_Funct||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO||': No Concurrent Program Flex for for this NGO';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/